// BigNumberDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "BigNumber.h"
#include "BigNumberDlg.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBigNumberDlg Dialogfeld

CBigNumberDlg::CBigNumberDlg(CWnd* pParent /*=NULL*/)
	: ETSLayoutDialog(CBigNumberDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBigNumberDlg)
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bDistoStart = false;
	m_bDistoConnected = false;
}

void CBigNumberDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBigNumberDlg)
	DDX_Control(pDX, IDC_STATIC_DISPLAY, m_Display);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBigNumberDlg, ETSLayoutDialog)
	//{{AFX_MSG_MAP(CBigNumberDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBigNumberDlg Nachrichten-Handler

BOOL CBigNumberDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	CreateRoot(VERTICAL)

		//	OpenGL: Koordinatenhaufen
		<< (pane( HORIZONTAL, GREEDY) 
				<< item ( IDC_STATIC_DISPLAY,	ALIGN_FILL )
		   )

		//	CListCtrlEx: Koordinatenliste
		<< (pane( HORIZONTAL, ABSOLUTE_VERT) 
				<< item ( IDC_BUTTON_START,			ALIGN_FILL )
				<< item ( IDC_BUTTON_STOP,			ALIGN_FILL )
				<< itemGrowing( HORIZONTAL )
				<< item ( IDC_STATIC_BITMAP,		NORESIZE   )
		   );
	
	m_Display.SetText("0.0");

	UpdateLayout();

	SetDisplayFontSize();

	m_ReceiveWindow.m_pDisplay = &m_Display;
	m_ReceiveWindow.Create();

	EnableControls();

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CBigNumberDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CBigNumberDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CBigNumberDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CBigNumberDlg::OnButtonStart() 
{
	StartDisto();
	m_Disto.StartTrackingMeasure();
}

void CBigNumberDlg::OnButtonStop() 
{
	m_Disto.StopTrackingMeasure();
}

void CBigNumberDlg::OnSize(UINT nType, int cx, int cy) 
{
	ETSLayoutDialog::OnSize(nType, cx, cy);
	SetDisplayFontSize();
}

void 
CBigNumberDlg::SetDisplayFontSize(int iSize)
{
	if(!iSize)
	{
		CRect aRect;
		m_Display.GetWindowRect(aRect);

		double iYSize = aRect.Height();
		double iXSize = aRect.Width();

		double k;
		
		k = fabs((iXSize - iYSize)/iXSize);
		TRACE("k: %f iYSize %f iXSize %f",k,iYSize,iXSize);

		iYSize *= k*1.5;

		if(iYSize > aRect.Height()-5) iYSize = aRect.Height()-5;

		if(iYSize > 10)
		{
			m_Display.SetFontSize((int)iYSize);
		}
	}
	else
	{
		m_Display.SetFontSize(iSize);
	}
}

//	Ein beliebiges Control enable / disablen
#define EnableCtrl(id)			(GetDlgItem(id)->EnableWindow())
#define DisableCtrl(id)			(GetDlgItem(id)->EnableWindow(0))


void
CBigNumberDlg::EnableControls()
{
	if(m_bDistoConnected)
	{
		EnableCtrl(IDC_BUTTON_STOP);
	}
	else
	{
		DisableCtrl(IDC_BUTTON_STOP);
	}
}



void CBigNumberDlg::StartDisto()
{
	if(!m_bDistoStart)
	{
		m_bDistoStart = true;

		SetDisplayFontSize(20);

		if(!m_Disto.CreateDispatch("Disto2.Application"))
		{
			m_Display.SetText(_T("Kann DISTO online nicht starten"));
		}
		else
		{
			//	Check for DISTOs
			CWaitCursor aWaitCursor;

			m_Display.SetText(_T("Suche DISTO..."));
			

			Sleep(500);

			m_bDistoConnected = m_Disto.IsDistoConnected(50);

			if(!m_bDistoConnected)
			{
				m_Display.SetText(_T("Kein DISTO angeschlossen!"));
			}
			else
			{
				Sleep(500);						//	Disto Seriennummer senden lassen
				HWND hWnd = m_ReceiveWindow.GetSafeHwnd();

				m_Disto.SetSendModeToWindow((long)hWnd);
				m_Display.SetText("");
				SetDisplayFontSize();
			}
		}
	}
	else
	{
		if(!m_bDistoConnected)
		{
			m_bDistoConnected = m_Disto.FindDisto();

			if(!m_bDistoConnected)
			{
				SetDisplayFontSize(20);
				m_Display.SetText(_T("Kein DISTO angeschlossen!"));
			}
		}
	}
	EnableControls();
}

