// Von Klassen-Assistent automatisch erstellte IDispatch-Kapselungsklasse(n). 
/////////////////////////////////////////////////////////////////////////////
// Wrapper-Klasse IDisto2 

class IDisto2 : public COleDispatchDriver
{
public:
	IDisto2() {}		// Ruft den Standardkonstruktor fr COleDispatchDriver auf
	IDisto2(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IDisto2(const IDisto2& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attribute
public:
	BOOL GetBvisible();
	void SetBvisible(BOOL);

// Operationen
public:
	void LaserOn();
	void LaserOff();
	void StartSingleMeasure();
	void StartTrackingMeasure();
	void StopTrackingMeasure();
	void SetAutoMeasureIntervall(long Interval);
	LPDISPATCH SingleMeasure(short Timeout);
	LPDISPATCH GetFirstMeasurement();
	LPDISPATCH GetLastMeasurement();
	long GetNbrMeasurement();
	LPDISPATCH GetMeasurement(long Index);
	void ClearMeasureLog();
	long SaveMeasureLogToFile(LPCTSTR Filename);
	long LoadMeasureLogFromFile(LPCTSTR Filename);
	long IsDistoConnected(short Timeout);
	CString DistoSerialnumber();
	CString DistoVersion();
	CString DistoType();
	long FindDisto();
	CString GetDistoComPortName();
	long GetDistoComPortBaud();
	short GetDistoComPortData();
	CString GetDistoComPortParity();
	CString GetDistoComPortStopBit();
	CString GetDistoComPort();
	void SetDistoComPort(LPCTSTR ComSettings);
	void SetSendModeProtokollOnly();
	void SetSendModeToCurrentInput();
	void SetSendModeToWindow(long hWnd);
	void SetSendModeUserFormat(LPCTSTR DataFormat);
	CString GetSendModeUserFormat();
	void SetProgramModeSimple();
	void SetProgramModeExpert();
	void SetDecimalSeperatorPoint();
	void SetDecimalSeperatorSystem();
	void DistoAccessCode(LPCTSTR Code);
	long DistoCmdGetSerialNumber();
	long DistoCmdSendMemory();
	long DistoCmdSendPartMemory(short Start, short End);
	long DistoCmdDeleteMemory();
	long DistoCmdReceiveLanguageFile(LPCTSTR Filename);
	long DistoCmdReceiveUsercodeFile(LPCTSTR Filename);
	short DistoTypeInternal();
	void StartSingleMeasureAngle();
	LPDISPATCH SingleMeasureAngle(short Timeout);
};
/////////////////////////////////////////////////////////////////////////////
// Wrapper-Klasse IDistoMeasureProxy 

class IDistoMeasureProxy : public COleDispatchDriver
{
public:
	IDistoMeasureProxy() {}		// Ruft den Standardkonstruktor fr COleDispatchDriver auf
	IDistoMeasureProxy(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IDistoMeasureProxy(const IDistoMeasureProxy& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attribute
public:

// Operationen
public:
	BOOL IsValid();
	double Value();
	CString Unit();
	BOOL IsDistance();
	BOOL IsArea();
	BOOL IsVolume();
	BOOL IsAngle();
	CString Time();
	CString TimeMS();
	CString Date();
	DATE DateTime();
	long Position();
	double MinValue();
	double MaxValue();
	CString CodeA();
	CString CodeB();
	CString CodeC();
	CString KeyCode();
	CString ValueUserFormat();
	long ErrorCode();
	CString ErrorString();
	long RawValue();
	short RawUnit();
	CString ValueString();
	CString MinValueString();
	CString MaxValueString();
	BOOL IsTimeout();
	CString UserString();
	double Angle();
	CString AngleUnit();
};
